<?php
include("config.php");
function validate_name($data) { /* функция валидации имени пользователя */
	$err=""; /* присваиваем переменной $err пустую строку */
	if(strlen($data)<2 || strlen($data)>50) /* если длина имени меньше 2 или больше 50 символов*/
		$err = "Длина имени должна быть от 2 до 50 символов"; /* записываем в переменную $err сообщение об ошибке */
	if (preg_match("/[^(\w)|(\x7F-\xFF)|(\s)]/",$data))  /* если в имени содержатся недопустимые символы */
        $err = $err . "<p>В написании имени допустимы только буквы латинского и русского алфавитов, цифры, символ подчеркивания и пробел</p>"; /* записываем в переменную $err сообщение об ошибке */
    if(!empty($err)) /*при наличии ошибки*/
        return ($err); /* возвращаем сообщение об ошибке */
    else 
    	return 0;
}
function validate_email($data) { /* функция валидации email-адреса пользователя */
	$err =""; /* присваиваем переменной $err пустую строку */
	if(strlen($data)<3 || strlen($data)>50) /* если длина emaila меньше 2 или больше 50 символов*/
		$err = "Email должен быть от 3 до 50 символов"; /* записываем в переменную $err сообщение об ошибке */
    if(!preg_match('#^([\w]+\.?)+(?<!\.)@(?!\.)[a-zа-я0-9ё\.-]+\.?[a-zа-яё]{2,}$#ui', $data)) /* если введенный адрес недопустимого формата */
	   $err = $err . "<p>Недопустимый формат email-адреса</p>"; /* записываем в переменную $err сообщение об ошибке */
	if(!empty($err)) /*при наличии ошибки*/
		return $err;  /* возвращаем сообщение об ошибке */
	else
		return 0;
}
function validate_inputs($data_name,$data_email){ /* функция валидации имени пользователя и */
    $err="";
    $err_name = validate_name($data_name); /* вызываем функцию валидации имени пользователя */
    $err_email = validate_email($data_email); /* вызываем функцию валидации emaila пользователя */
    if(!empty($err_name)) /* если имя введено с ошибками */
    	$err = $err_name; /* в переменную $err записываем текст ошибки */
    if(!empty($err_email)) /* если email введен с ошибками*/
    	$err = $err . $err_email; /* в переменную $err записываем текст ошибки */
    return $err; 
}
if(isset($_POST['submit_form'])) /* если получены данные из формы */
{
 $name=$_POST["user_name"]; /* в переменную $name передаем введенное пользователем имя */
 $email=$_POST["email"];  /*  в переменную $email передаем введенное пользователем email */
 $error_form = validate_inputs($name, $email);  /* вызываем функцию валидации формы */
 if(!empty($error_form)){ /* если при валидации обнаружены ошибки */
 	echo $error_form;  /* выводим сообщение об ошибках */
 }
 else{ /* иначе - вызываем подготовленный запрос */
    $prepared = $mysqli->prepare("select id, name, email from subscribe where email = ?");
    $prepared->bind_param("s", $email);
    $prepared->execute();
    $prepared->store_result();
    if($prepared->num_rows === 0){
        $prepared = $mysqli->prepare("insert into subscribe values('',?,?)"); /* формируем запрос, в котором вместо параметров записаны символы вопросительного знака */
        $prepared->bind_param("ss",$name, $email); /* привязываем переменные имени и emaila параметрам запроса */
        if($prepared->execute())  /* если запрос выполнен, сообщаем об успехе */
        	echo "Поздравляем! Подписка успешно оформлена! ";
        else  /*иначе - сообщаем об ошибке*/
        	echo "Ошибка запроса";
        $prepared->close();  /*закрываем подготавливаемый запрос*/
        
    }
    else
   	    echo "Такой email уже зарегистрирован";
    }
 }
?>